<'
# Copyright (c) 2012 LAAS/CNRS
# All rights reserved.
#
# Redistribution and use  in source  and binary  forms,  with or without
# modification, are permitted provided that the following conditions are
# met:
#
#   1. Redistributions of  source  code must retain the  above copyright
#      notice and this list of conditions.
#   2. Redistributions in binary form must reproduce the above copyright
#      notice and  this list of  conditions in the  documentation and/or
#      other materials provided with the distribution.
#
#                                      Anthony Mallet on Thu Aug  2 2012
#

if {[llength $argv] != 1} { error "expected arguments: component" }
lassign $argv component

# compute handy shortcuts
set comp [$component name]
set COMP [string toupper [$component name]]

lang c
'>
#include "autoconf/acheader.h"

#include "genom3/c/client.h"
#include "<"$comp">/c/client.h"


/* --- error messages ------------------------------------------------------ */

const char * const genom_<"$comp">_client_emap[] = {
<'foreach m [[$component event] members] {'>
  [<"[$m declarator]">] = "<"[$m fullname]">",
<'}'>
  "<invalid error code>"
};
const unsigned int genom_<"$comp">_client_elen =
  sizeof(genom_<"$comp">_client_emap)/sizeof(*genom_<"$comp">_client_emap);


/* --- component info ------------------------------------------------------ */

static const struct genom_service_info genom_service_info[] = {
<'foreach s [$component services] {'>
  {
    .name = "<"[$s name]">",
    .input = "<"[string map {\" \\\"} [json-param $s in inout]]">",
    .output = "<"[string map {\" \\\"} [json-param $s inout out]]">",
    .meta = "<"[string map {\" \\\"} [json-param-meta $s in inout out]]">",
    .init_input =
    (genom_initfn)genom_<"$comp">_client_<"[$s name]">_init_input,
    .init_output =
    (genom_initfn)genom_<"$comp">_client_<"[$s name]">_init_output,
    .fini_input =
    (genom_finifn)genom_<"$comp">_client_<"[$s name]">_fini_input,
    .fini_output =
    (genom_finifn)genom_<"$comp">_client_<"[$s name]">_fini_output,
    .json_scan =
    (genom_json_scanfn)genom_<"$comp">_client_<"[$s name]">_json_scan,
    .json_print =
    (genom_json_printfn)genom_<"$comp">_client_<"[$s name]">_json_print,
    .send =
    (genom_request_sendfn)genom_<"$comp">_client_<"[$s name]">_rqst,
    .input_size = sizeof(struct genom_<"$comp">_<"[$s name]">_input),
    .output_size = sizeof(struct genom_<"$comp">_<"[$s name]">_output)
  },
<'}'>
  { .name = NULL, .input = NULL, .output = NULL, .meta = NULL, .send = NULL }
};

static const struct genom_port_info genom_port_info[] = {
<'foreach p [$component ports out] {'>
  {
    .name = "<"[$p name]">",
    .data = "<"[string map {\" \\\"} [json-port $p]]">",
    .meta = "<"[string map {\" \\\"} [json-port-meta $p]]">",
    .init_data =
    (genom_initfn)genom_<"$comp">_client_<"[$p name]">_init_data,
    .fini_data =
    (genom_finifn)genom_<"$comp">_client_<"[$p name]">_fini_data,
    .json_print =
    (genom_json_printfn)genom_<"$comp">_client_<"[$p name]">_json_print,
<'  if {"multiple" in [$p kind]} {'>
    .simple = 0,
    .read.multiple =
    (genom_port_multiple_readfn)genom_<"$comp">_client_<"[$p name]">_port,
<'  } else {'>
    .simple = 1,
    .read.simple =
    (genom_port_readfn)genom_<"$comp">_client_<"[$p name]">_port,
<'  }'>
    .data_size = sizeof(<"[[$p datatype] declarator]">)
  },
<'}'>
  { .name = NULL, .data = NULL, .meta = NULL,
    .init_data = NULL, .fini_data = NULL, .json_print = NULL,
    .simple = 1, .read.simple = NULL, .data_size = 0
  }
};

const struct genom_client_info genom_<"$comp">_client_info = {
  .protocol = genom_client_protocol,
  .name = "<"$comp">",

  .init = genom_<"$comp">_client_init,
  .fini = genom_<"$comp">_client_fini,
  .instance = genom_<"$comp">_client_instance,
  .eventfd = genom_<"$comp">_client_eventfd,
  .service_info = genom_<"$comp">_client_service_info,
  .done = genom_<"$comp">_client_done,
  .wait = genom_<"$comp">_client_wait,
  .clean = genom_<"$comp">_client_clean,
  .doevents = genom_<"$comp">_client_doevents,
  .strerror = genom_<"$comp">_client_strerror,

  .nservices = <"[llength [$component services]]">,
  .services = genom_service_info,

  .nports = <"[llength [$component ports out]]">,
  .ports = genom_port_info
};

<'set x 0; foreach s [$component services] {'>
const struct genom_service_info *genom_<"$comp">_client_<"[$s name]">_info =
  &genom_service_info[<"$x">];
<'  incr x }'>

<'set x 0; foreach p [$component ports out] {'>
const struct genom_port_info *genom_<"$comp">_client_<"[$p name]">_info =
  &genom_port_info[<"$x">];
<'  incr x }'>

